/* $Id: QITabWidget.cpp $ */
/** @file
 * VBox Qt GUI - Qt extensions: QITabWidget class implementation.
 */

/*
 * Copyright (C) 2010-2024 Oracle and/or its affiliates.
 *
 * This file is part of VirtualBox base platform packages, as
 * available from https://www.virtualbox.org.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation, in version 3 of the
 * License.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <https://www.gnu.org/licenses>.
 *
 * SPDX-License-Identifier: GPL-3.0-only
 */

/* GUI includes: */
#include "QITabWidget.h"


QITabWidget::QITabWidget(QWidget *pParent /* = 0 */)
    : QTabWidget(pParent)
{
#ifdef VBOX_WS_MAC
    // WORKAROUND:
    // I don't know why, but for some languages there is
    // ElideRight the default on Mac OS X. Fix this.
    setElideMode(Qt::ElideNone);
#endif
}
